
package geometry;

public class Matrix4 {
	double[][] m = { { 1, 0, 0, 0 }, { 0, 1, 0, 0 }, { 0, 0, 1, 0 },
			{ 0, 0, 0, 1 } };

	public Matrix4() {
             
	}

	public Matrix4(double angle, int s) {
		switch (s) {
		case 0:
			m[1][1] = Math.cos(angle);
			m[1][2] = Math.sin(angle) * -1;
			m[2][1] = Math.sin(angle);
			m[2][2] = Math.cos(angle);
			break;
		case 1:
			m[0][0] = Math.cos(angle);
			m[0][2] = Math.sin(angle) * -1;
			m[2][0] = Math.sin(angle);
			m[2][2] = Math.cos(angle);
			break;
		case 2:
			m[0][0] = Math.cos(angle);
			m[0][1] = Math.sin(angle) * -1;
			m[1][0] = Math.sin(angle);
			m[1][1] = Math.cos(angle);
			break;
		}
	}

	public Point mul(Point point) {
		double bX = point.getX();
		double bY = point.getY();
		double bZ = point.getZ();
		double a = m[0][0] * bX + m[0][1] * bY + m[0][2] * bZ + m[0][3] * 1;
		double b = m[1][0] * bX + m[1][1] * bY + m[1][2] * bZ + m[1][3] * 1;
		double c = m[2][0] * bX + m[2][1] * bY + m[2][2] * bZ + m[2][3] * 1;
		Point b1 = new Point(a, b, c);
		return b1;
	}


}
