package geometry;

public class Vector {
	private final Point pos;
	private final Point dir;

	public Vector(Point pos, Point dir) {
		this.pos = pos;
		this.dir = dir;
	}

	public Vector refractedT(float nT, float nO, Point n) {

		double nI = dir.cosTheta(n);
		if (nI > 0) {
			nT = nO / nT;
		} else {
			nT = nT / nO;
			n = n.mulConst(-1);
			nI = dir.cosTheta(n);
		}

		double sq = 1 - nT * nT * (1 - nI * nI);
		if (sq < 0) {
			Vector v = new Vector(getPos(), getDir().reflected(n));
			return v;
		}
		double k = nT * nI - Math.sqrt(sq);
		Point a = n.mulConst(k);
		Point b = dir.mulConst(nT);
		Point v = a.subPoint(b);
		Vector refracted;
		refracted = new Vector(getPos(), v);
		return refracted;
	}

	public Point mulConst(double t) {
		return pos.sumPoint(dir.mulConst(t));
	}

	public Point getPos() {
		return pos;
	}

	public Point getDir() {
		return dir;
	}

}