
package graphics;

import geometry.Point;

public final class PhongModel{

	private int h;
	private float iL=0.8f;
	private float rD;
	private float rS;
	private float rA;
    
	public PhongModel(float rD,float rS,float rA, int h) {
		this.rD = rD;
		this.rS = rS;
		this.rA = rA;
		this.h = h;
	}
	
	
	private float countDifus(Point l, Point n) {
		
		float k = 0;
		if (l.mulSkal(n)>0) {
			k = iL*rD*(float)l.mulSkal(n);
		}
		return k;
	}
	
	private float countSpecular(Point v, Point r) {
		float k = 0;
		if (v.mulSkal(r)>0) {
			k = iL*rS*(float)Math.pow(v.mulSkal(r), h);
		}
		return k;
	}

	
	public float countKoef(Point v, Point l, Point n, Point r) {
		float specular = countSpecular(v,r);
		float diffuse = countDifus(l,n);
		float ambient=iL*rA;
		float k = specular+diffuse+ambient;
		return k;
	}
	public float getrS() {
		return rS;
	}
	public void setrS(float rS) {
		this.rS = rS;
	}


}