package gui;

import java.awt.Canvas;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;

public class WindowCanvas extends Canvas {

	private static final long serialVersionUID = 1L;

	private Image pic = null;
	private int width;
	private int height;

	public WindowCanvas(int width, int height) {
		this.width = width;
		this.height = height;
	}

	public Dimension getMinimumSize() {
		return new Dimension(width, height);
	}
    
	public Dimension getPreferredSize() {
		return getMinimumSize();
	}

	public void drawPic(Image pic) {
		this.pic = pic;
		repaint();
	}
  
	public void update(Graphics g) {
		paint(g);
	}

	public void paint(Graphics g) {
		Dimension d = getSize();
		if (pic != null) {
			g.drawImage(pic, 0, 0, d.width, d.height, this);
		}
	}

	public Image getPic() {
		return pic;
	}
}
