
package objects;

import java.util.ArrayList;
import java.util.List;

import geometry.Point;
import geometry.Intersection;
import geometry.Vector;

public class ObjectsList {

	private List<Objects> list = new ArrayList<Objects>();

	public List<Objects> getList() {
		return list;
	}

	public void setSeznam(List<Objects> list) {
		this.list = list;
	}

	public boolean add(Objects object) {
		return list.add(object);
	}

	public Intersection findCloser(Vector v) {
		double parametr = Double.POSITIVE_INFINITY;
		Intersection p1 = null;
		for (Objects t : list) {
			Intersection p = t.findIntersection(v);
			if (p != null) {
				if (p.getParameterT() < parametr) {
					p1 = p;
					parametr = p.getParameterT();
				}
			}
		}
		return p1;
	}

	public float shadowRay(Vector v, Point lightPos) {

		float shade = 1;
		lightPos = lightPos.subPoint(v.getPos());
		double size1 = lightPos.size();
		Intersection pT = findCloser(v);

		if (pT != null) {
			double size2 = pT.getParameterT();
			if (size1 > size2 && pT.getT().getSurface().getLom()[0] == 0) {
				return 0;
			} else {
				if (size1 > size2 && pT.getT().getSurface().getLom()[0] > 0) {

					shade = (float) 0.5;

				}
			}

		}
		return shade;
	}
}
