
package objects.props;

import java.awt.Color;

import graphics.PhongModel;

public class Surface {
	private Color color;
	private Texture tex;
	private PhongModel phongModel;
	public PhongModel getPhongModel() {
		return phongModel;
	}

	public void setPhongModel(PhongModel phongModel) {
		this.phongModel = phongModel;
	}

	private float[] lom;

	public Surface(Color color, PhongModel phongModel,
			float[] lom, Texture tex) {
		this.color = color;
		this.lom = lom;
		this.tex = tex;
		this.phongModel = phongModel;
	}
	
	public Surface(Color color, PhongModel model,
			float[] lom) {
		this.color = color;
		this.lom = lom;
		this.phongModel = model;
	}

	public Color getColor() {
		if (getTexture() == null) {
			return color;
		} else {
			return Color.WHITE;
		}
	}

	public float[] getColorFloat() {
		if (getTexture() == null) {
			float[] barvaFloat = { color.getRed() / 255,
					color.getGreen() / 255, color.getBlue() / 255 };
			return barvaFloat;
		} else {
			float[] barvaFloat = { 1, 1, 1 };
			return barvaFloat;
		}
	}

	public Color getColorUV(double[] uv) {
		if (getTexture() == null) {
			return color;
		} else {
			Color c = getTexture().vratBarvu(uv[0], uv[1]);
			return c;
		}
	}


	public Texture getTexture() {
		return tex;
	}

	public void setTexture(Texture tex) {
		this.tex = tex;
	}

	public float[] getLom() {
		return lom;
	}

	public void setLom(float[] lom) {
		this.lom = lom;
	}

	public void setColor(Color color) {
		this.color = color;
	}
}